<CsoundSynthesizer>
<CsOptions>
-o bell.wav -W -d --messagelevel=2
</CsOptions>
; ==============================================
<CsInstruments>

sr	=	48000
ksmps	=	1
nchnls	=	2
0dbfs	=	1


#include "m_scene_bell_mf.udo"
#include "m_scene_bell_noise.udo"
#include "m_scene_bell_pd.udo"
#include "m_scene_bell_phone.udo"
#include "m_scene_bell_tone.udo"

; Produce a single multifrequency tone, these were used for internal network
; routing purposes
; p4 = iTone, p5 = SoutputChannel
instr Play_MF
	iTone init p4
	Schannel strget p5

	if iTone == 0 then
		aTone m_scene_bell_mf "0"
	elseif iTone == 1 then
		aTone m_scene_bell_mf "1"
	elseif iTone == 2 then
		aTone m_scene_bell_mf "2"
	elseif iTone == 3 then
		aTone m_scene_bell_mf "3"
	elseif iTone == 4 then
		aTone m_scene_bell_mf "4"
	elseif iTone == 5 then
		aTone m_scene_bell_mf "5"
	elseif iTone == 6 then
		aTone m_scene_bell_mf "6"
	elseif iTone == 7 then
		aTone m_scene_bell_mf "7"
	elseif iTone == 8 then
		aTone m_scene_bell_mf "8"
	elseif iTone == 9 then
		aTone m_scene_bell_mf "9"
	elseif iTone == 10 then
		aTone m_scene_bell_mf "KP"
	elseif iTone == 11 then
		aTone m_scene_bell_mf "KP2"
	elseif iTone == 12 then
		aTone m_scene_bell_mf "ST"
	endif
	chnmix aTone*.01, Schannel
endin

; Dial multiple MF tones (see Play_mf for details)
; p4 = iToneLength, p5 = iInterval, p6 = SoutputChannel
instr Dial_mf
	iInterval init p5
	if p4 >= (iInterval * .9) then
		iLength init iInterval * .9
	else
		iLength init p4
	endif
	Schannel strget p6

	; Set up random number generator
	kTrigger metro 1/iInterval
	kRandom randh 6.5, 1/iInterval
	kMFIndex init 0
	
	if kTrigger != 0 then
		kMFIndex = int(kRandom + 6.5)
		schedulek "Play_MF", 0, iLength, kMFIndex, Schannel
	endif
endin

; Play a progress tone
; p4 = Stone, p5 = Schannel
instr Play_Tone
	Stone init p4
	Schannel strget p5
	aTone m_scene_bell_tone Stone
	chnmix aTone*.4, Schannel
endin

; Dial one digit (with pulse dial)
; p4 = iDigit, p5 = Schannel
instr Play_pd
	iDigit init p4
	Schannel strget p5

	aTone m_scene_bell_pd iDigit, .5, 1
	chnmix aTone*.7, Schannel
endin

; Dial a Number based, on an ftable
; p4 = iNumberFt, p5 = Schannel
instr Dial_pd
	iNumberFt init p4
	Schannel strget p5
	iDigits = ftlen(iNumberFt)

	; Dial the number
	iIndex init 0
	while iIndex < iDigits do
		iCurDigit tab_i iIndex, iNumberFt, 0
		schedule "Play_pd", (iIndex * 1.1), 1.1, iCurDigit, Schannel
		iIndex += 1
	od
	turnoff
endin

; Play general line noise
; p4 = iType, p5 = Schannel
instr Play_noise
	iType init p4
	Schannel strget p5

	aTone m_scene_bell_noise .5, .1, .8, iType
	chnmix aTone*.5, Schannel
endin

; Play audiofile
; p4 = SaudioFile, p5 = iVolume, p6 = Schannel
instr PlayFile
	Sfile init p4
	iVolume init p5
	Schannel strget p6

	aSound soundin Sfile
	chnmix aSound*iVolume, Schannel
endin

; Play a channel unprocessed
; p4 = Schannel
instr Play
	Schannel init p4

	aSound chnget Schannel
	chnclear Schannel
	outs aSound, aSound
endin

; Play a channel through a phone speaker
; p4 = Schannel
instr Play_phone
	Schannel init p4

	aSound chnget Schannel
	chnclear Schannel
	aOut m_scene_bell_phone aSound, .5, .5
	outs aOut, aOut
endin

</CsInstruments>
; ==============================================
<CsScore>
f1 0 -11 -2 0 8 0 0 1 5 0 7 0 9 0

i"Play_phone" 0 -1 "Phone"
i"Play" 0 -1 "Clean"
i"Play_noise" 0 7.4 0 "Phone"
i"Play_Tone" 7.4 .1 "click" "Phone"
i"Play_noise" 7.5 43.8 1 "Phone"
i"Play_Tone" 0 3 "dial" "Phone"
i"Dial_pd" 3 .1 1 "Phone"
i"Dial_mf" 7 7 .1 .12 "Phone"
i"Play_Tone" 15.2 .1 "click" "Phone"
i"Play_Tone" 15.3 12 "ring" "Phone"
i"Play_Tone" 27.3 .1 "con" "Phone"
i"PlayFile" 27.4 1.9 "out1.wav" .8 "Phone"
i"PlayFile" 29.3 2.5 "out2.wav" .8 "Clean"
i"PlayFile" 31.8 4.4 "out3.wav" .8 "Phone"
i"PlayFile" 36.2 10.2 "out4.wav" .8 "Clean"
i"PlayFile" 46.4 2.4 "out5.wav" .8 "Phone"
i"PlayFile" 48.8 2.3 "out6.wav" .8 "Clean"
i"Play_Tone" 51.1 .1 "con" "Phone"
i"Play_Tone" 51.3 8 "busy" "Phone"
i"Play_noise" 51.3 8 0 "Phone"
e
</CsScore>
</CsoundSynthesizer>
